pcl::registration::CorrespondenceRejectorMedianDistance Class Reference
Module registration

CorrespondenceRejectorMedianDistance implements a simple correspondence rejection method based on thresholding based on the median distance between the correspondences. More...

`#include <pcl/registration/correspondence_rejection_median_distance.h>`

Inheritance diagram for pcl::registration::CorrespondenceRejectorMedianDistance:

## Public Types

typedef boost::shared_ptr< CorrespondenceRejectorMedianDistance > | Ptr
typedef boost::shared_ptr< const CorrespondenceRejectorMedianDistance > | ConstPtr
Public Types inherited from pcl::registration::CorrespondenceRejector
typedef boost::shared_ptr< CorrespondenceRejector > | Ptr
typedef boost::shared_ptr< const CorrespondenceRejector > | ConstPtr

## Public Member Functions

| CorrespondenceRejectorMedianDistance ()
| Empty constructor. More...
void | getRemainingCorrespondences (const pcl::Correspondences &original_correspondences, pcl::Correspondences &remaining_correspondences)
| Get a list of valid correspondences after rejection from the original set of correspondences. More...
double | getMedianDistance () const
| Get the median distance used for thresholding in correspondence rejection. More...
template<typename PointT >
void | setInputSource (const typename pcl::PointCloud< PointT >::ConstPtr &cloud)
| Provide a source point cloud dataset (must contain XYZ data!), used to compute the correspondence distance. More...
template<typename PointT >
void | setInputCloud (const typename pcl::PointCloud< PointT >::ConstPtr &cloud)
| Provide a source point cloud dataset (must contain XYZ data!), used to compute the correspondence distance. More...
template<typename PointT >
void | setInputTarget (const typename pcl::PointCloud< PointT >::ConstPtr &target)
| Provide a target point cloud dataset (must contain XYZ data!), used to compute the correspondence distance. More...
bool | requiresSourcePoints () const
| See if this rejector requires source points. More...
void | setSourcePoints (pcl::PCLPointCloud2::ConstPtr cloud2)
| Blob method for setting the source cloud. More...
bool | requiresTargetPoints () const
| See if this rejector requires a target cloud. More...
void | setTargetPoints (pcl::PCLPointCloud2::ConstPtr cloud2)
| Method for setting the target cloud. More...
template<typename PointT >
void | setSearchMethodTarget (const boost::shared_ptr< pcl::search::KdTree< PointT > > &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the target cloud. More...
void | setMedianFactor (double factor)
| Set the factor for correspondence rejection. More...
double | getMedianFactor () const
| Get the factor used for thresholding in correspondence rejection. More...
Public Member Functions inherited from pcl::registration::CorrespondenceRejector
| CorrespondenceRejector ()
| Empty constructor. More...
virtual | ~CorrespondenceRejector ()
| Empty destructor. More...
virtual void | setInputCorrespondences (const CorrespondencesConstPtr &correspondences)
| Provide a pointer to the vector of the input correspondences. More...
CorrespondencesConstPtr | getInputCorrespondences ()
| Get a pointer to the vector of the input correspondences. More...
void | getCorrespondences (pcl::Correspondences &correspondences)
| Run correspondence rejection. More...
void | getRejectedQueryIndices (const pcl::Correspondences &correspondences, std::vector< int > &indices)
| Determine the indices of query points of correspondences that have been rejected, i.e., the difference between the input correspondences (set via setInputCorrespondences) and the given correspondence vector. More...
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | requiresSourceNormals () const
| See if this rejector requires source normals. More...
virtual void | setSourceNormals (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the source normals. More...
virtual bool | requiresTargetNormals () const
| See if this rejector requires target normals. More...
virtual void | setTargetNormals (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the target normals. More...

## Protected Types

typedef boost::shared_ptr< DataContainerInterface > | DataContainerPtr

## Protected Member Functions

void | applyRejection (pcl::Correspondences &correspondences)
| Apply the rejection algorithm. More...

## Protected Attributes

double | median_distance_
| The median distance threshold between two correspondent points in source <-> target. More...
double | factor_
| The factor for correspondence rejection. More...
DataContainerPtr | data_container_
| A pointer to the DataContainer object containing the input and target point clouds. More...
Protected Attributes inherited from pcl::registration::CorrespondenceRejector
std::string | rejection_name_
| The name of the rejection method. More...
CorrespondencesConstPtr | input_correspondences_
| The input correspondences. More...

## Detailed Description

CorrespondenceRejectorMedianDistance implements a simple correspondence rejection method based on thresholding based on the median distance between the correspondences.

Note
  If setInputCloud and setInputTarget are given, then the distances between correspondences will be estimated using the given XYZ data, and not read from the set of input correspondences.

Author
  Aravindhan K Krishnan. This code is ported from libpointmatcher (https://github.com/ethz-asl/libpointmatcher)

Definition at line 61 of file correspondence_rejection_median_distance.h.

## Member Typedef Documentation

## ConstPtr

typedef boost::shared_ptr<const CorrespondenceRejectorMedianDistance> pcl::registration::CorrespondenceRejectorMedianDistance::ConstPtr

Definition at line 69 of file correspondence_rejection_median_distance.h.

## DataContainerPtr

typedef boost::shared_ptr<DataContainerInterface> pcl::registration::CorrespondenceRejectorMedianDistance::DataContainerPtr

protected

Definition at line 203 of file correspondence_rejection_median_distance.h.

## Ptr

typedef boost::shared_ptr<CorrespondenceRejectorMedianDistance> pcl::registration::CorrespondenceRejectorMedianDistance::Ptr

Definition at line 68 of file correspondence_rejection_median_distance.h.

## Constructor & Destructor Documentation

## CorrespondenceRejectorMedianDistance()

pcl::registration::CorrespondenceRejectorMedianDistance::CorrespondenceRejectorMedianDistance | ( |  | ) |

inline

Empty constructor.

Definition at line 72 of file correspondence_rejection_median_distance.h.

## Member Function Documentation

## applyRejection()

void pcl::registration::CorrespondenceRejectorMedianDistance::applyRejection | ( | pcl::Correspondences & | correspondences | ) |

inline protected virtual

Apply the rejection algorithm.

Parameters

  [out] | correspondences | the set of resultant correspondences.

Implements pcl::registration::CorrespondenceRejector.

Definition at line 189 of file correspondence_rejection_median_distance.h.

## getMedianDistance()

double pcl::registration::CorrespondenceRejectorMedianDistance::getMedianDistance | ( |  | ) | const

inline

Get the median distance used for thresholding in correspondence rejection.

Definition at line 90 of file correspondence_rejection_median_distance.h.

## getMedianFactor()

double pcl::registration::CorrespondenceRejectorMedianDistance::getMedianFactor | ( |  | ) | const

inline

Get the factor used for thresholding in correspondence rejection.

Definition at line 181 of file correspondence_rejection_median_distance.h.

## getRemainingCorrespondences()

void pcl::registration::CorrespondenceRejectorMedianDistance::getRemainingCorrespondences | ( | const pcl::Correspondences & | original_correspondences,
|  | pcl::Correspondences & | remaining_correspondences
| ) |  |

virtual

Get a list of valid correspondences after rejection from the original set of correspondences.

Parameters

  [in] | original_correspondences | the set of initial correspondences given
  [out] | remaining_correspondences | the resultant filtered set of remaining correspondences

Implements pcl::registration::CorrespondenceRejector.

## requiresSourcePoints()

bool pcl::registration::CorrespondenceRejectorMedianDistance::requiresSourcePoints | ( |  | ) | const

inline virtual

See if this rejector requires source points.

Reimplemented from pcl::registration::CorrespondenceRejector.

Definition at line 131 of file correspondence_rejection_median_distance.h.

## requiresTargetPoints()

bool pcl::registration::CorrespondenceRejectorMedianDistance::requiresTargetPoints | ( |  | ) | const

inline virtual

See if this rejector requires a target cloud.

Reimplemented from pcl::registration::CorrespondenceRejector.

Definition at line 145 of file correspondence_rejection_median_distance.h.

## setInputCloud()

template<typename PointT >

void pcl::registration::CorrespondenceRejectorMedianDistance::setInputCloud | ( | const typename pcl::PointCloud< PointT >::ConstPtr & | cloud | ) |

inline

Provide a source point cloud dataset (must contain XYZ data!), used to compute the correspondence distance.

Parameters

  [in] | cloud | a cloud containing XYZ data

Definition at line 109 of file correspondence_rejection_median_distance.h.

## setInputSource()

template<typename PointT >

void pcl::registration::CorrespondenceRejectorMedianDistance::setInputSource | ( | const typename pcl::PointCloud< PointT >::ConstPtr & | cloud | ) |

inline

Provide a source point cloud dataset (must contain XYZ data!), used to compute the correspondence distance.

Parameters

  [in] | cloud | a cloud containing XYZ data

Definition at line 97 of file correspondence_rejection_median_distance.h.

## setInputTarget()

template<typename PointT >

void pcl::registration::CorrespondenceRejectorMedianDistance::setInputTarget | ( | const typename pcl::PointCloud< PointT >::ConstPtr & | target | ) |

inline

Provide a target point cloud dataset (must contain XYZ data!), used to compute the correspondence distance.

Parameters

  [in] | target | a cloud containing XYZ data

Definition at line 122 of file correspondence_rejection_median_distance.h.

## setMedianFactor()

void pcl::registration::CorrespondenceRejectorMedianDistance::setMedianFactor | ( | double | factor | ) |

inline

Set the factor for correspondence rejection.

Points with distance greater than median times factor will be rejected

Parameters

  [in] | factor | value

Definition at line 177 of file correspondence_rejection_median_distance.h.

## setSearchMethodTarget()

template<typename PointT >

void pcl::registration::CorrespondenceRejectorMedianDistance::setSearchMethodTarget | ( | const boost::shared_ptr< pcl::search::KdTree< PointT > > & | tree,
|  | bool | force_no_recompute = `false`
| ) |  |

inline

Provide a pointer to the search object used to find correspondences in the target cloud.

Parameters

  [in] | tree | a pointer to the spatial search object.
  [in] | force_no_recompute | If set to true, this tree will NEVER be recomputed, regardless of calls to setInputTarget. Only use if you are confident that the tree will be set correctly.

Definition at line 165 of file correspondence_rejection_median_distance.h.

## setSourcePoints()

void pcl::registration::CorrespondenceRejectorMedianDistance::setSourcePoints | ( | pcl::PCLPointCloud2::ConstPtr | cloud2 | ) |

inline virtual

Blob method for setting the source cloud.

Reimplemented from pcl::registration::CorrespondenceRejector.

Definition at line 136 of file correspondence_rejection_median_distance.h.

References pcl::fromPCLPointCloud2().

## setTargetPoints()

void pcl::registration::CorrespondenceRejectorMedianDistance::setTargetPoints | ( | pcl::PCLPointCloud2::ConstPtr | cloud2 | ) |

inline virtual

Method for setting the target cloud.

Reimplemented from pcl::registration::CorrespondenceRejector.

Definition at line 150 of file correspondence_rejection_median_distance.h.

References pcl::fromPCLPointCloud2().

## Member Data Documentation

## data_container_

DataContainerPtr pcl::registration::CorrespondenceRejectorMedianDistance::data_container_

protected

A pointer to the DataContainer object containing the input and target point clouds.

Definition at line 206 of file correspondence_rejection_median_distance.h.

## factor_

double pcl::registration::CorrespondenceRejectorMedianDistance::factor_

protected

The factor for correspondence rejection.

Points with distance greater than median times factor will be rejected

Definition at line 201 of file correspondence_rejection_median_distance.h.

## median_distance_

double pcl::registration::CorrespondenceRejectorMedianDistance::median_distance_

protected

The median distance threshold between two correspondent points in source <-> target.

Definition at line 196 of file correspondence_rejection_median_distance.h.

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/registration/include/pcl/registration/correspondence_rejection_median_distance.h